// colorRecognition.h

#ifndef _COLORRECOGNITION_h
#define _COLORRECOGNITION_h

#if defined(ARDUINO) && ARDUINO >= 100
	#include "arduino.h"
#else
	#include "WProgram.h"
#endif

#define COLOR_SLAVE_ADDRESS 10

class ColorRecognitionClass
{
 protected:

 public:
	void begin();
	void startConvert(void);
	boolean getStatus(void);
	void getRGB(uint8_t &R, uint8_t &G, uint8_t &B);
	void colourBalance(uint8_t &R, uint8_t &G, uint8_t &B, float &scale_r, float &scale_g, float &scale_b);
	void RGB2HSV(uint8_t R, uint8_t G, uint8_t B, uint16_t &H, float &S, float &V);
	void HSV2RGB(uint16_t H, float S, float V, uint8_t  &R, uint8_t &G, uint8_t &B);
};

//extern ColorRecognitionClass ColorRecognition;

#endif

