/*
颜色识别功能描述;把想识别的颜色放在颜色识别模块上，调整一定的高度RGB灯可显示出相应的颜色（PS:不是所有的颜色显示都是100%准确的）

*/
#include "colorRecognition.h"// 检测颜色
#include "Adafruit_NeoPixel.h"  //led

#define PIN_RGB_LED 8
#define PIN_RLED    6
#define PIN_GLED    7
#define PIN_BLED    2
#define PIN_COLOR   A3

Adafruit_NeoPixel rgbLed(64, PIN_RGB_LED);
ColorRecognitionClass ColorRecognition;

float scaleR, scaleG, scaleB;
uint8_t r, g, b;

static void draw(void);
static void getColor(void);
static void rgbLedTest(void);


void setup() {
 Serial.begin(9600);
 ColorRecognition.begin();
 pinMode(PIN_RGB_LED, OUTPUT);
 rgbLed.begin();
 rgbLed.setBrightness(10);     
}

void loop() {
 getColor();//识别颜色
 if((r>28&&r<34)&&(g>28&&g<34)&&(b>28&&b<34))
 {
     rgbLed.clear();
    rgbLed.show();
 }
 else 
 {
     rgbLedTest();
      }
}

static void getColor(void)
{
  ColorRecognition.startConvert();
  delay(90);
  ColorRecognition.getStatus();
  //获取RGB值
  ColorRecognition.getRGB(r, g, b);
  //  }

  Serial.print("g: ");  Serial.print(g);
  Serial.print("  b: ");  Serial.print(b);
  Serial.print("  r: ");  Serial.print(r);
  Serial.println("");
}

static void rgbLedTest(void)
{
    for(int i=0;i<64;i++)
    rgbLed.setPixelColor(i, r, g, b);
    rgbLed.show();
}


