/*
 心跳功能描述：手指轻放在模块上时，8x8点阵灯会相应显示出心跳的图形
 
*/
#include <SPI.h>
#include <Wire.h>
#include <SoftwareSerial.h>
#include "Adafruit_NeoPixel.h"  //led
#include "MAX30100_PulseOximeter.h"// 心率
//#include "U8glib.h" //显示屏

#define PIN_RGB_LED 8

Adafruit_NeoPixel rgbLed(64, PIN_RGB_LED);
//U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE | U8G_I2C_OPT_DEV_0);  // I2C / TWI 

float hr;
uint8_t spo2;
float temperature;
PulseOximeter pox;
uint32_t tsLastReport = 0;
uint32_t ledT=0;

static void rgbLedTest(void);
static void draw(void);

void setup() {
Serial.begin(9600);  
   rgbLed.setBrightness(10);

if (!pox.begin()) {
  Serial.println("FAILED");
  for (;;);
}
else {
  Serial.println("SUCCESS");
}
pox.setIRLedCurrent(MAX30100_LED_CURR_7_6MA);
pinMode(PIN_RGB_LED, OUTPUT);
rgbLed.begin();
//u8g.setFont(u8g_font_9x15);
}

void loop() {
 pox.update();
//    u8g.firstPage();
//  do {
//    draw();
//  } while (u8g.nextPage());
   if (millis() - tsLastReport > 500) {
     
      hr = pox.getHeartRate();
      spo2 = pox.getSpO2();
      temperature = pox.getTemperature();
      tsLastReport = millis();
      Serial.println(hr);
     
     if(hr>0){
           
        rgbLedTest();
        
        }
     if(hr==0)
     {
       rgbLed.clear();
       rgbLed.show();
      } 
   }
         
}

//static void draw(void)
//{
//    u8g.drawStr(0, 16, "HR: ");
//    u8g.setPrintPos(60, 16);
//    u8g.print(hr);
//}
  
static void biglove(void)
{
    for (int i = 16; i < 40; i++)
    rgbLed.setPixelColor(i, 30, 0, 0);//红  0-50代表光度强度
  
    int a = 9, b = 10, c = 13, d = 14, e = 59, f = 60;
    rgbLed.setPixelColor(a, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(b, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(c, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(d, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(e, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(f, 30, 0, 0);//红  0-50代表光度强度
  
    for (int t = 41; t<47; t++)
    rgbLed.setPixelColor(t, 30, 0, 0);//红  0-50代表光度强度
  
    for (int j = 50; j<54; j++)
    rgbLed.setPixelColor(j, 30, 0, 0);//红  0-50代表光度强度
  
    if(millis()-ledT>(60/hr)*1000)
    {
       rgbLed.show();
      rgbLed.clear();
      ledT=millis();
      } 
}
/********************************************

*********************************************/

static void slove(void)
{
    for (int i = 25; i < 31; i++)
    rgbLed.setPixelColor(i, 30, 0, 0);//红  0-50代表光度强度
  
    int a = 27, b = 28, c = 51, d = 52, e = 17, f = 18, g = 21, h = 22;
    rgbLed.setPixelColor(a, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(b, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(c, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(d, 30, 0, 0);//红  0-50代表光度强度
    //rgbLed.setPixelColor(e, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(f, 30, 0, 0);//红  0-50代表光度强度
    rgbLed.setPixelColor(g, 30, 0, 0);//红  0-50代表光度强度
   // rgbLed.setPixelColor(h, 30, 0, 0);//红  0-50代表光度强度
  
    for (int t = 33; t<39; t++)
    rgbLed.setPixelColor(t, 30, 0, 0);//红  0-50代表光度强度
  
  
  
    for (int j = 42; j<46; j++)
    rgbLed.setPixelColor(j, 30, 0, 0);//红  0-50代表光度强度  
    rgbLed.show();
}

static void rgbLedTest(void)
{    
    slove();
    biglove(); 
}
