/*
贪吃蛇玩法描述：1.游戏开始：开始时，小蛇将向右移动，.蛇通过遥杆控制，在每吃到食物时，身体的长度就会加一，同时速度也会有轻微的变化，吃到一定程度时， 速度将不会再变化。
                2.游戏结束：吃到自己或者撞墙，就会结束游戏，RGBLed灯将会显示“囧”字，显示大概两秒后，重新开始游戏。

*/
#include "Adafruit_NeoPixel.h"  //led

#define PIN_RGB_LED 8
#define PIN_PS1     A1
#define PIN_PS2     A2
#define UP 9
#define DOWN 7
#define LEFT 8
#define RIGHT 6

Adafruit_NeoPixel rgbLed(64, PIN_RGB_LED);
int ps1Val, ps2Val;
uint32_t delayMs,foodDelay;
int Speed=1000;//初始速度
int socre;
uint8_t s[128];
int key_temp,key; 
int FX,FY; //食物的坐标
int SX,SY; //蛇头的坐标

static void Random();//随机生成食物
static void eatFood();//吃到食物
static void paintFood();//显示食物
static void read_key();//获取按键
static void moveSnake();//移动蛇
static void gameOver();//游戏结束
           
void setup()
{
  pinMode(PIN_RGB_LED, OUTPUT);
  rgbLed.begin();
  rgbLed.setBrightness(50);
  
  s[0]=2;s[1]=4;
  s[2]=1;s[3]=4;
  s[4]=0;s[5]=4; //初始化蛇的身体坐标

  Random();//食物
  Random();//食物
  key_temp=RIGHT;//初始方向
  socre=0;
  for(int i=0;i<=5;i=i+2)
    {
      rgbLed.setPixelColor(s[i]+s[i+1]*8, 8,0,0);
    }  
    rgbLed.show(); //初始蛇的三个坐标
 }
  
void loop()
{    
    s[0]=2;s[1]=4;
    s[2]=1;s[3]=4;
    s[4]=0;s[5]=4;//重置蛇的坐标
    key=RIGHT;//重置方向
    Speed=1000; 
    socre = 0;

 while(1)
   {
    paintFood();//显示食物
    read_key();//获取按键
    moveSnake();//移动蛇
 SX=s[0];SY=s[1]; //获取蛇头
    eatFood();//吃到食物
 for(int i=2;i<6+2*socre;i=i+2)//吃到自己
  {
    if( SX == s[i] && SY == s[i + 1])
      {     
        rgbLed.clear();
        rgbLed.show();//清屏
     gameOver();  //游戏结束  囧
     break;
        }                             
  }

  if(SX>7||SY>7||SX<0||SY<0)//撞墙
  {
      rgbLed.clear();
      rgbLed.show();//清屏
     gameOver();  //游戏结束  囧
      break;
    }
  }
}
void read_key()
{
  ps1Val = analogRead(PIN_PS1);
  ps2Val = analogRead(PIN_PS2);
  if ( ps1Val>200&&ps1Val<600&&ps2Val>900) { //上
    key_temp=UP;
  }
  if (ps1Val>400&&ps1Val<1000&&ps2Val<50) { //下
    key_temp=DOWN;
  }
  if (ps1Val<50&&ps2Val>0) { //左
    key_temp=LEFT;
  }
  if ( ps1Val>900&&ps2Val>400) { //右
    key_temp=RIGHT;   
  }
/*
蛇不能转身
*/
 if(key_temp==UP&&key!=DOWN)    { key=UP ;}
 if(key_temp==DOWN&&key!=UP)    { key=DOWN ;}
 if(key_temp==LEFT&&key!=RIGHT) { key=LEFT ;}
 if(key_temp==RIGHT&&key!=LEFT) { key=RIGHT ;}

}

void moveSnake()
 {
     if(millis()-delayMs>Speed)//每一秒显示蛇
    {  
      if(key==UP)//向上
     {
      for(int i=4+2*socre;i>0;i=i-2)
        {
         s[i]=s[i-2];
         s[i+1]=s[i-1];
        }
       s[1]=s[1]-1;
      }
       if(key==DOWN)//向下
     {
       for(int i=4+2*socre;i>0;i=i-2)
        {
         s[i]=s[i-2];
         s[i+1]=s[i-1];
        }
       s[1]=s[1]+1;
      }
       if(key==LEFT)//向左
      {
        for(int i=4+2*socre;i>0;i=i-2)
        {
         s[i]=s[i-2];
         s[i+1]=s[i-1];
        }
       s[0]=s[0]-1;
      }
     if(key==RIGHT)//向右
      {
      for(int i=4+2*socre;i>0;i=i-2)
        {
         s[i]=s[i-2];
         s[i+1]=s[i-1];
        }      
       s[0]=s[0]+1;
      }
        rgbLed.clear();
      rgbLed.show();
      for(int i=0;i<6+2*socre;i=i+2)//绘画蛇三个点
      {
        rgbLed.setPixelColor(s[i]+s[i+1]*8, 8,0,0);
      }  
      rgbLed.show();  
      delayMs=millis();
     } 
  }

void Random()
{ 
  FX=random(0,8);
  FY=random(0,8);
  for(int i=0;i<6+2*socre;i=i+2)
  {
  if(FX==s[i]&&SY==s[i+1])
    {
       FX=random(0,8);
       FY=random(0,8);
    }
  }
}

void eatFood()//吃到食物
 {
 if(SX==FX&&SY==FY)
   { 
    socre=socre+1;
    Random();  
    Speed=Speed-40;
    if(Speed<=200)
    {
      Speed=200;
      }    
   }  
 }
 
 void paintFood()//显示食物
 {
  if(millis()-foodDelay>50)
   {
      rgbLed.setPixelColor(FX+FY*8,10,8,0);
      rgbLed.show(); 
     foodDelay=millis();
   }
 }

 void gameOver(void)
{
    int c=0,d=7,e=34,f=37;
  for(int a= 0;a<=7;a++)
  {
  rgbLed.setPixelColor(a,8,0,0);
  }
 for(int b=56;b<=63;b++)
  {
    rgbLed.setPixelColor(b,8,0,0);
    }
 for(int i=0;i<8;i++)
 {
  c=c+8;
  rgbLed.setPixelColor(c,8,0,0);
  }
for(int i=0;i<8;i++)
 {
  d=d+8;
  rgbLed.setPixelColor(d,8,0,0);
 }
 rgbLed.setPixelColor(10,8,0,0);
 rgbLed.setPixelColor(13,8,0,0);
 rgbLed.setPixelColor(17,8,0,0);
 rgbLed.setPixelColor(22,8,0,0);
 for(int i=0;i<3;i++)
 {
  rgbLed.setPixelColor(e,8,0,0);
   e=e+8;
  }
for(int i=0;i<3;i++)
 {
  rgbLed.setPixelColor(f,8,0,0);
   f=f+8;
  }
 rgbLed.setPixelColor(35,8,0,0);
 rgbLed.setPixelColor(36,8,0,0);    //描绘囧字
 rgbLed.show(); 
 delay(2000);
 rgbLed.clear();
 rgbLed.show();
//重置蛇的坐标
  s[0]=2;s[1]=4;
  s[2]=1;s[3]=4;
  s[4]=0;s[5]=4;
  key_temp=RIGHT;//重置方向
 Speed=1000; 
 socre = 0;
  for(int i=0;i<6;i=i+2)//绘画蛇三个点
      {
        rgbLed.setPixelColor(s[i]+s[i+1]*8, 8,0,0);
      }  
      rgbLed.show(); 
      delay(1000);
}


